
#include "setHSPE/noise.fxh"
#define time TIME*.4

/*
Please permission first. if you used this code:)
Twitter: @DevHSPE
Facebook: Wanzekk
Youtube: Wanze'
*/

float beam(in float2 p){
	float2 p2 = p*.7;
	float2 beampos = float2(noise(p2-time*1.8),noise(p2+time*1.5));
	beampos = (beampos-.5)*.2;
	p += beampos;
	return noise(mul(p,makem2(time*.2)));}

float3 sunbeam(float3 result, float3 hsc, float3 hswp, float3 hsp, detection at){
                       float beam1 = 2.*atan(.7);
                    float beam2 = (beam1*beam1+2.);
                  float3 beamcolor = float3(1.,.5,.1);
           float beamdist = smoothstep(1.,0.,length(hsc.xy));
          float beamshape = smoothstep(0.,.5,length(hswp.zy)*.03);
   float2 beampos = float2((atan(hswp.y/hswp.z)/beam2)*4.8, length(hsp.xz));
   result += beam(beampos.x*3.5)*5.3*at.dusk*at.sunset*(1.-at.rain)*beamdist*beamshape*beamcolor;
                            return result;}

     float wet_wave(float3 poss){
   float wave = pow(noise(float2(poss.x+poss.z+poss.z+TIME*.35,poss.z+poss.x+poss.x+TIME*.28)*1.5),2.5); 
   wave = clamp(length(wave),0., 2.5);
     return wave;}
       
    float puddle(float3 poss,detection at){
     float wet =  clamp(length(noise(poss.xz*.7))*.2,.0,2.);
    return wet*(1.-at.night)*at.rain;}

    float refleksi(float3 wp, float3 R, detection at){
   float ref1 = .5;
  float ref2 = 1.;
   float nolight = (1.-at.rain);
    float3 reflectPos = normalize(float3(-4, 1, 0)-wp);
   float3 reflectDir = reflect(reflectPos,R);
  float reflection = pow(max(dot(reflectDir, R), 0.),5.);
   return ref1*reflection*ref2*nolight;}


