

//World Color
float3 clrWorld(float3 clrW, detection at){
clrW = lerp(float3(1.7,1.7,1.7),float3(1.2,1.3,1.3), at.day);
clrW = lerp(clrW, float3(.2,-.5,-2.), at.dusk);
clrW = lerp(clrW, float3(2.5,2.5,2.5), at.rain);
clrW = lerp(clrW, float3(2.,2.,4.5), at.night);
clrW = lerp(clrW, float3(1.,1.,1.), at.cave);
return clrW;}

//Water Color
float3 clrWater(float3 clrWtr, detection at){
clrWtr = lerp(float3(.0,.535,.9), float3(.0,.3,.7), at.dusk);
clrWtr = lerp(clrWtr, float3(.0, .3, .8), at.rain);
clrWtr = lerp(clrWtr, float3(.05, .15, .5), at.night);
clrWtr = lerp(clrWtr, float3(.0,.1,.2), at.cave);
return clrWtr;}

//Torch Color
float3 light(float3 result,other clr,float shx,  detection at){
float nolight; 
float lightUp;
nolight = lerp(1.,.15,at.day);
nolight = lerp(nolight,1.,at.cave);
nolight = lerp(nolight,.95,at.night);
nolight = lerp(nolight, 1., at.rain);
lightUp = pow(shx*.92,2.7);
clr.Torch = float3(1.2,.2,-.8);
result = clr.Torch*nolight*lightUp;
return result;}

//Shadow
float3 shadow(float3 shd, other clr, float shside, float shy){
if((.867>shy)||(.604>shside)){
shd.rgb *= clr.Shadows;}
if((.868>shy)||(.608>shside)){
shd.rgb *= clr.Shadows;}
if((.869>shy)||(.6012>shside)){
shd.rgb *= clr.Shadows;}
if((.87>shy)||(.616>shside)){
shd.rgb *= clr.Shadows;}
if((.871>shy)||(.62>shside)){
shd.rgb *= clr.Shadows;}
if((.872>shy)||(.624>shside)){
shd.rgb *= clr.Shadows;}
if((.873>shy)||(.628>shside)){
shd.rgb *= clr.Shadows;}
if((.874>shy)||(.632>shside)){
shd.rgb *= clr.Shadows;}
return shd;}

//Buwung apa tu man
float rayPos(in float3 pos, float yPos){
float3 np = normalize(pos);
float sun = abs(1.-length(np.yz));
float hah = smoothstep((8.5-yPos) + abs(np.y)*2.4,0.,abs(np.z)*1.7);
float3 Pos = float3(hah, hah, hah);
float hih = max(0.,sun);
float3 flatRange = float3(hih,hih,hih);
return pow(max(dot(Pos, flatRange), 0.0),5.0);}
float3 raySun(in float3 pos, float3 x){
float specularFlat = rayPos(pos,1.4);
x *= float3(1.2,1.,.0)*specularFlat;
return x;}


