// __multiversion__
// This signals the loading code to prepend either #version 100 or #version 300 es as apropriate.

/*
please permission first.
before you used this code:)
twitter : @DevHSPE
*/

#include "fragmentVersionSimple.h"
#include "uniformShaderConstants.h"
#include "setHSPE/struct.h"
#include "setHSPE/library.h"

varying vec4 color;
varying highp vec3 w_pos;

uniform highp float TIME;
uniform vec4 FOG_COLOR;
uniform vec2 FOG_CONTROL;

void main(){

//vector
vec4 alpha = color;
vec4 fc = FOG_COLOR;
vec2 fcc = FOG_CONTROL;

detection at;
at.rain = (1.-pow(fcc.y, 11.));
at.night = pow(max(min(1.-fc.r *1.5,1.),.0),1.2);
at.day = pow(max(min(1.-fc.b*1.2,1.), .0), .5);

alpha.r = max(alpha.r, 3.);
alpha.g = max(alpha.g, 7.);
alpha.b = max(alpha.b, 7.);

vec4 stars = lerp(fc, alpha, at.day);

gl_FragColor = float4(alpha.rgb*CURRENT_COLOR.rgb*float3(0.,9.,9.)*cos(TIME*.1*alpha.a)*alpha.a*.9+.2, alpha.a*stars);}