#include "ShaderConstants.fxh"
#include "setHSPE/struct.fxh"

/*
Please permission first. if you used this code:)
Twitter: @DevHSPE
Facebook: Wanzekk
Youtube: Wanze'
*/

struct PS_Input
{
    float4 position : SV_Position;
    float4 color : COLOR;
};

struct PS_Output
{
    float4 color : SV_Target;
};

ROOT_SIGNATURE
void main(in PS_Input PSInput, out PS_Output PSOutput)
{

float4 alpha = PSInput.color;
float4 fc = FOG_COLOR;
float2 fcc = FOG_CONTROL;

detection at;
at.rain = (1.-pow(fcc.y, 11.));
at.night = pow(max(min(1.-fc.r *1.5,1.),.0),1.2);
at.day = pow(max(min(1.-fc.b*1.2,1.), .0), .5);

alpha.r = max(alpha.r, 3.);
alpha.g = max(alpha.g, 7.);
alpha.b = max(alpha.b, 7.);
float4 stars = lerp(fc, alpha, at.day);
 
 
 PSOutput.color = PSInput.color*cos(TIME*.1*alpha.a)*(alpha.a*stars);
 PSOutput.color.rgb *= CURRENT_COLOR.rgb * PSInput.color.a*float3(.0,.9,.9);
}